/*
 *  Copyright (c) 2016 Intel Corporation.
 *  Intel Corporation All Rights Reserved.
 *
 *  Portions of the source code contained or described herein and all documents related
 *  to portions of the source code ("Material") are owned by Intel Corporation or its
 *  suppliers or licensors.  Title to the Material remains with Intel
 *  Corporation or its suppliers and licensors.  The Material contains trade
 *  secrets and proprietary and confidential information of Intel or its
 *  suppliers and licensors.  The Material is protected by worldwide copyright
 *  and trade secret laws and treaty provisions.  No part of the Material may
 *  be used, copied, reproduced, modified, published, uploaded, posted,
 *  transmitted, distributed, or disclosed in any way without Intel's prior
 *  express written permission.
 *
 *  No license under any patent, copyright, trade secret or other intellectual
 *  property right is granted to or conferred upon you by disclosure or
 *  delivery of the Materials, either expressly, by implication, inducement,
 *  estoppel or otherwise. Any license under such intellectual property rights
 *  must be express and approved by Intel in writing.
 */
#include <hStreams_sink.h>
#include <stdio.h>
#include <omp.h>
#include <string.h>
#include <math.h>

HSTREAMS_EXPORT
void vector_add(uint64_t N, uint64_t id, uint64_t AA, uint64_t BB, uint64_t CC)
{
    system("/bin/hostname");
    printf("sink: compute on sink in stream num: %ld\n", id);
    double *A;
    double *B;
    double *C;

    A = (double *) AA;
    B = (double *) BB;
    C = (double *) CC;
    
    long int n = (long int) N;
    #pragma omp parallel for 
    for (long int i = 0; i < n; ++i) 
        C[i] = A[i] + B[i];
}
